searchData={"items":[{"type":"module","title":"nuntius","doc":"The main interface for the system.","ref":"nuntius.html"},{"type":"function","title":"nuntius.delete/1","doc":"Removes a mocking process.","ref":"nuntius.html#delete/1"},{"type":"function","title":"nuntius.delete/2","doc":"Removes an expect function. If the expect function was not already there, this function still returns 'ok'. If the process is not mocked, an error is returned.","ref":"nuntius.html#delete/2"},{"type":"function","title":"nuntius.expect/2","doc":"Adds a new expect function to a mocked process. When a message is received by the process, this function will be run on it. If the message doesn't match any clause, the process might exit, depending on option exit_on_nomatch . If the process is not mocked, an error is returned. When the function is successfully added, a reference is returned as an identifier.","ref":"nuntius.html#expect/2"},{"type":"function","title":"nuntius.expect/3","doc":"Adds a new named expect function to a mocked process. When a message is received by the process, this function will be run on it. If the message doesn't match any clause, the process might exit, depending on option exit_on_nomatch . If the process is not mocked, an error is returned. If there was already an expect function with that name, it's replaced. When the expect function is successfully added or replaced, it'll keep the name as its identifier.","ref":"nuntius.html#expect/3"},{"type":"function","title":"nuntius.expects/1","doc":"Returns the list of expect functions for a process.","ref":"nuntius.html#expects/1"},{"type":"function","title":"nuntius.history/1","doc":"Returns the history of messages received by a mocked process.","ref":"nuntius.html#history/1"},{"type":"function","title":"nuntius.mocked/0","doc":"Returns the list of mocked processes.","ref":"nuntius.html#mocked/0"},{"type":"function","title":"nuntius.mocked_process/0","doc":"Returns the PID of the currently mocked process. Note : this code should only be used inside an expect fun.","ref":"nuntius.html#mocked_process/0"},{"type":"function","title":"nuntius.mocked_process/1","doc":"Returns the PID of a mocked process (the original one with that name).","ref":"nuntius.html#mocked_process/1"},{"type":"function","title":"nuntius.new/1","doc":"Equivalent to new(ProcessName, #{}) . Injects a new mock process in front of the process with the provided name. Returns an error if there is no process registered under that name.","ref":"nuntius.html#new/1"},{"type":"function","title":"nuntius.new/2","doc":"Injects a new mock process in front of the process with the provided name. Options: passthrough : if true , all messages are passed through to the process by default. If false, messages that are not handled by any expectation are just dropped. default: true history : if true , the mocking process will keep the history of messages received. default: true exit_on_nomatch : if true , the mocking process will exit with an exception if none of the expectations match the message. Otherwise it'll silently ignore it. default: true","ref":"nuntius.html#new/2"},{"type":"function","title":"nuntius.passthrough/0","doc":"Passes the current message down to the mocked process. Note : this code should only be used inside an expect fun.","ref":"nuntius.html#passthrough/0"},{"type":"function","title":"nuntius.passthrough/1","doc":"Passes a message down to the mocked process. Note : this code should only be used inside an expect fun.","ref":"nuntius.html#passthrough/1"},{"type":"function","title":"nuntius.received/2","doc":"Returns whether a particular message was received already. Note : it only works with history =&gt; true.","ref":"nuntius.html#received/2"},{"type":"function","title":"nuntius.reset_history/1","doc":"Erases the history for a mocked process.","ref":"nuntius.html#reset_history/1"},{"type":"function","title":"nuntius.start/0","doc":"Equivalent to application:ensure_all_started(nuntius) . Starts the application.","ref":"nuntius.html#start/0"},{"type":"function","title":"nuntius.stop/0","doc":"Stops the application.","ref":"nuntius.html#stop/0"},{"type":"type","title":"nuntius.event/0","doc":null,"ref":"nuntius.html#t:event/0"},{"type":"type","title":"nuntius.expect_fun/0","doc":null,"ref":"nuntius.html#t:expect_fun/0"},{"type":"type","title":"nuntius.expect_id/0","doc":null,"ref":"nuntius.html#t:expect_id/0"},{"type":"type","title":"nuntius.expect_name/0","doc":null,"ref":"nuntius.html#t:expect_name/0"},{"type":"type","title":"nuntius.message/0","doc":null,"ref":"nuntius.html#t:message/0"},{"type":"type","title":"nuntius.opts/0","doc":null,"ref":"nuntius.html#t:opts/0"},{"type":"type","title":"nuntius.process_name/0","doc":null,"ref":"nuntius.html#t:process_name/0"},{"type":"extras","title":"nuntius","doc":"# nuntius [![Erlang CI][ci-img]][ci]\n\n[ci]: https://github.com/2Latinos/nuntius/actions/workflows/erlang.yml\n[ci-img]: https://github.com/2Latinos/nuntius/actions/workflows/erlang.yml/badge.svg\n\nnuntius is an Erlang/OTP library to mock registered processes. Its main use case is to intercept\nmessages sent to specific processes and to allow the consumer to act upon them.","ref":"readme.html"},{"type":"extras","title":"Usage - nuntius","doc":"nuntius is best used via [rebar3](https://rebar3.org/)'s `test` profile and using Erlang/OTP's\n[Common Test framework](https://www.erlang.org/doc/man/common_test.html):\n\n1\\. change your `rebar.config` to include:\n\n```erlang\n{profiles, [{test, [{deps, [nuntius]}]}]}.\n```\n\n2\\. run your nuntius-enabled tests with:\n\n```shell\nrebar3 ct\n```","ref":"readme.html#usage"},{"type":"extras","title":"Features - nuntius","doc":"* places mock processes in front of previously registered processes; these mock processes will\nintercept (and optionally handle) every message that was supposed to go to the latter ones, then\n  * allows mock processes to decide on letting the messages pass through, or not,\n  * allows mock processes to run one or many pre-processing functions on each received message,\n  * allows mock processes to discard intercepted messages entirely,\n  * allows history collection of messages received by the mock processes for further analysis.","ref":"readme.html#features"},{"type":"extras","title":"Options for the mock process - nuntius","doc":"The following parameters allow you to configure the interaction between the mock and mocked\nprocesses, as well as other elements for debugging:\n\n* `passthrough`: when `true` (default: `true`) all messages received by the mock process are\npassed through to the mocked process,\n* `history`: when `true` (default: `true`) all messages received by the mock process are\nclassified as per [Understanding the message history](#understanding-the-message-history),\n* `exit_on_nomatch`: (default: `true`) check [Expectation handling](#expectation-handling) below.","ref":"readme.html#options-for-the-mock-process"},{"type":"extras","title":"Understanding the message history - nuntius","doc":"History elements are classified with 6 keys:\n\n* `timestamp`: an integer representing Erlang system time in native time unit,\n* `message`: the message that was received and/or potentially handled by expectations\n(or passed through),\n* `mocked`: an indication of whether or not any of the expectations you declared handled\nthe message,\n* `with`: the expectation return value,\n* `stack`: the stack trace, in case of an exception,\n* `passed_through`: an indication of whether or not the received message was passed through to\nthe mocked process.","ref":"readme.html#understanding-the-message-history"},{"type":"extras","title":"Expectation handling - nuntius","doc":"If, when nuntius executes your expectations, none matches the input (which means it's better\nto have a catch-all) it'll exit with `{nuntius, nomatch, StackTrace}`. This can be prevented by\nusing option `exit_on_nomatch` as `false` (the default is to exit).\n\nOn the other hand, if an exception occurs inside one of your expectations, nuntius will\nalso exit with `{nuntius, nomatch, StackTrace}` so you can analyze what needs to be fixed.","ref":"readme.html#expectation-handling"},{"type":"extras","title":"Documentation - nuntius","doc":"Documentation is generated with:\n\n```shell\nrebar3 ex_doc\n```\n\nafter which you can use your favorite Web browser to open `doc/index.html`.\n\nIt is also available, online, at [hexdocs.pm/nuntius](https://hexdocs.pm/nuntius/).","ref":"readme.html#documentation"},{"type":"extras","title":"Examples - nuntius","doc":"Examples are found at [github.com/nuntius/examples](https://github.com/2Latinos/nuntius/tree/main/examples).","ref":"readme.html#examples"},{"type":"extras","title":"Versioning - nuntius","doc":"This project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).","ref":"readme.html#versioning"},{"type":"extras","title":"Readme - nuntius","doc":"We get inspiration for our README's format/content from\n[Make a README](https://www.makeareadme.com/).","ref":"readme.html#readme"},{"type":"extras","title":"Changelog - nuntius","doc":"All notable changes to this project will be referenced from the [CHANGELOG](CHANGELOG.md).","ref":"readme.html#changelog"},{"type":"extras","title":"Contributing - nuntius","doc":"Though this project is maintained by [2Latinos](https://github.com/2Latinos) contributions are\naccepted and welcome. Check [CONTRIBUTING.md](CONTRIBUTING.md) for more.","ref":"readme.html#contributing"},{"type":"extras","title":"License - nuntius","doc":"Check [LICENSE.md](LICENSE.md).","ref":"readme.html#license"},{"type":"extras","title":"Security policy","doc":"# Security policy\n\nThanks for helping make nuntius safer for everyone.\n\nFind below updated information on our security policy.","ref":"security.html"},{"type":"extras","title":"Security - Security policy","doc":"We take the security of this software seriously.\n\nWe don't implement a bug bounty program or bounty rewards, but will work with\nyou to ensure that your findings get the appropriate handling.","ref":"security.html#security"},{"type":"extras","title":"Reporting Security Issues - Security policy","doc":"If you believe you have found a security vulnerability in this repository,\nplease report it to   or  .\n\nPlease do not report security vulnerabilities through public channels, like\nGitHub issues, discussions, or pull requests.\n\nPlease include as much of the information listed below as you can to help us\nbetter understand and resolve the issue:\n\n- the type of issue (e.g., buffer overflow, SQL injection, or cross-site\n  scripting)\n- full paths of source file(s) related to the manifestation of the issue\n- the location of the affected source code (tag/branch/commit or direct URL)\n- any special configuration required to reproduce the issue\n- step-by-step instructions to reproduce the issue\n- proof-of-concept or exploit code (if possible)\n- impact of the issue, including how an attacker might exploit the issue\n\nThis information will help us triage your report more quickly.","ref":"security.html#reporting-security-issues"},{"type":"extras","title":"Contributor Covenant Code of Conduct","doc":"# Contributor Covenant Code of Conduct","ref":"code_of_conduct.html"},{"type":"extras","title":"Our Pledge - Contributor Covenant Code of Conduct","doc":"We as members, contributors, and leaders pledge to make participation in our\ncommunity a harassment-free experience for everyone, regardless of age, body\nsize, visible or invisible disability, ethnicity, sex characteristics, gender\nidentity and expression, level of experience, education, socio-economic status,\nnationality, personal appearance, race, religion, or sexual identity\nand orientation.\n\nWe pledge to act and interact in ways that contribute to an open, welcoming,\ndiverse, inclusive, and healthy community.","ref":"code_of_conduct.html#our-pledge"},{"type":"extras","title":"Our Standards - Contributor Covenant Code of Conduct","doc":"Examples of behavior that contributes to a positive environment for our\ncommunity include:\n\n* Demonstrating empathy and kindness toward other people\n* Being respectful of differing opinions, viewpoints, and experiences\n* Giving and gracefully accepting constructive feedback\n* Accepting responsibility and apologizing to those affected by our mistakes,\n  and learning from the experience\n* Focusing on what is best not just for us as individuals, but for the\n  overall community\n\nExamples of unacceptable behavior include:\n\n* The use of sexualized language or imagery, and sexual attention or\n  advances of any kind\n* Trolling, insulting or derogatory comments, and personal or political attacks\n* Public or private harassment\n* Publishing others' private information, such as a physical or email\n  address, without their explicit permission\n* Other conduct which could reasonably be considered inappropriate in a\n  professional setting","ref":"code_of_conduct.html#our-standards"},{"type":"extras","title":"Enforcement Responsibilities - Contributor Covenant Code of Conduct","doc":"Community leaders are responsible for clarifying and enforcing our standards of\nacceptable behavior and will take appropriate and fair corrective action in\nresponse to any behavior that they deem inappropriate, threatening, offensive,\nor harmful.\n\nCommunity leaders have the right and responsibility to remove, edit, or reject\ncomments, commits, code, wiki edits, issues, and other contributions that are\nnot aligned to this Code of Conduct, and will communicate reasons for moderation\ndecisions when appropriate.","ref":"code_of_conduct.html#enforcement-responsibilities"},{"type":"extras","title":"Scope - Contributor Covenant Code of Conduct","doc":"This Code of Conduct applies within all community spaces, and also applies when\nan individual is officially representing the community in public spaces.\nExamples of representing our community include using an official e-mail address,\nposting via an official social media account, or acting as an appointed\nrepresentative at an online or offline event.","ref":"code_of_conduct.html#scope"},{"type":"extras","title":"Enforcement - Contributor Covenant Code of Conduct","doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be\nreported to the community leaders responsible for enforcement at\n  or  .\nAll complaints will be reviewed and investigated promptly and fairly.\n\nAll community leaders are obligated to respect the privacy and security of the\nreporter of any incident.","ref":"code_of_conduct.html#enforcement"},{"type":"extras","title":"Enforcement Guidelines - Contributor Covenant Code of Conduct","doc":"Community leaders will follow these Community Impact Guidelines in determining\nthe consequences for any action they deem in violation of this Code of Conduct:","ref":"code_of_conduct.html#enforcement-guidelines"},{"type":"extras","title":"1. Correction - Contributor Covenant Code of Conduct","doc":"**Community Impact**: Use of inappropriate language or other behavior deemed\nunprofessional or unwelcome in the community.\n\n**Consequence**: A private, written warning from community leaders, providing\nclarity around the nature of the violation and an explanation of why the\nbehavior was inappropriate. A public apology may be requested.","ref":"code_of_conduct.html#1-correction"},{"type":"extras","title":"2. Warning - Contributor Covenant Code of Conduct","doc":"**Community Impact**: A violation through a single incident or series\nof actions.\n\n**Consequence**: A warning with consequences for continued behavior. No\ninteraction with the people involved, including unsolicited interaction with\nthose enforcing the Code of Conduct, for a specified period of time. This\nincludes avoiding interactions in community spaces as well as external channels\nlike social media. Violating these terms may lead to a temporary or\npermanent ban.","ref":"code_of_conduct.html#2-warning"},{"type":"extras","title":"3. Temporary Ban - Contributor Covenant Code of Conduct","doc":"**Community Impact**: A serious violation of community standards, including\nsustained inappropriate behavior.\n\n**Consequence**: A temporary ban from any sort of interaction or public\ncommunication with the community for a specified period of time. No public or\nprivate interaction with the people involved, including unsolicited interaction\nwith those enforcing the Code of Conduct, is allowed during this period.\nViolating these terms may lead to a permanent ban.","ref":"code_of_conduct.html#3-temporary-ban"},{"type":"extras","title":"4. Permanent Ban - Contributor Covenant Code of Conduct","doc":"**Community Impact**: Demonstrating a pattern of violation of community\nstandards, including sustained inappropriate behavior,  harassment of an\nindividual, or aggression toward or disparagement of classes of individuals.\n\n**Consequence**: A permanent ban from any sort of public interaction within\nthe community.","ref":"code_of_conduct.html#4-permanent-ban"},{"type":"extras","title":"Attribution - Contributor Covenant Code of Conduct","doc":"This Code of Conduct is adapted from the [Contributor Covenant][homepage],\nversion 2.0, available at\n .\n\nCommunity Impact Guidelines were inspired by [Mozilla's code of conduct\nenforcement ladder](https://github.com/mozilla/diversity).\n\n[homepage]:  \n\nFor answers to common questions about this code of conduct, see the FAQ at\n . Translations are available at\n .","ref":"code_of_conduct.html#attribution"},{"type":"extras","title":"Contributing to nuntius","doc":"# Contributing to nuntius\n\n1. [License](#license)\n1. [Reporting a bug](#reporting-a-bug)\n1. [Requesting or implementing a feature](#requesting-or-implementing-a-feature)\n1. [Submitting your changes](#submitting-your-changes)\n   1. [Code Style](#code-style)\n   1. [Committing your changes](#committing-your-changes)\n   1. [Pull requests and branching](#pull-requests-and-branching)\n   1. [Credits](#credits)","ref":"contributing.html"},{"type":"extras","title":"License - Contributing to nuntius","doc":"nuntius is licensed under The [MIT](LICENSE.md) License, for all code.","ref":"contributing.html#license"},{"type":"extras","title":"Reporting a bug - Contributing to nuntius","doc":"nuntius is not perfect software and will be buggy.\n\nBugs can be reported via\n[GitHub issues: bug report](https://github.com/2Latinos/nuntius/issues/new?template=bug_report.md).\n\nSome contributors and maintainers may be unpaid developers working on nuntius, in their own time,\nwith limited resources. We ask for respect and understanding, and will provide the same back.\n\nIf your contribution is an actual bug fix, we ask you to include tests that, not only show the issue\nis solved, but help prevent future regressions related to it.","ref":"contributing.html#reporting-a-bug"},{"type":"extras","title":"Requesting or implementing a feature - Contributing to nuntius","doc":"Before requesting or implementing a new feature, do the following:\n\n- search, in existing [issues](https://github.com/2Latinos/nuntius/issues) (open or closed), whether\nthe feature might already be in the works, or has already been rejected,\n- make sure you're using the latest software release (or even the latest code, if you're going for\n_bleeding edge_).\n\nIf this is done, open up a\n[GitHub issues: feature request](https://github.com/2Latinos/nuntius/issues/new?template=feature_request.md).\n\nWe may discuss details with you regarding the implementation, and its inclusion within the project.\n\nWe try to have as many of nuntius' features tested as possible. Everything that a user can do,\nand is repeatable in any way, should be tested, to guarantee backwards compatible.","ref":"contributing.html#requesting-or-implementing-a-feature"},{"type":"extras","title":"Submitting your changes - Contributing to nuntius","doc":"","ref":"contributing.html#submitting-your-changes"},{"type":"extras","title":"Code Style - Contributing to nuntius","doc":"- do not introduce trailing whitespace\n- indentation is 4 spaces, not tabs\n- try not to introduce lines longer than 100 characters\n- write small functions whenever possible, and use descriptive names for functions and variables\n- comment tricky or non-obvious decisions made to explain their rationale","ref":"contributing.html#code-style"},{"type":"extras","title":"Committing your changes - Contributing to nuntius","doc":"Merging to the `main` branch will usually be preceded by a squash.\n\nWhile it's Ok (and expected) your commit messages relate to why a given change was made, be aware\nthat the final commit (the merge one) will be the issue title, so it's important it is as specific\nas possible. This will also help eventual automated changelog generation.","ref":"contributing.html#committing-your-changes"},{"type":"extras","title":"Pull requests and branching - Contributing to nuntius","doc":"All fixes to nuntius end up requiring a +1 from one or more of the project's maintainers.\n\nDuring the review process, you may be asked to correct or edit a few things before a final rebase\nto merge things. Do send edits as individual commits to allow for gradual and partial reviews to be\ndone by reviewers.","ref":"contributing.html#pull-requests-and-branching"},{"type":"extras","title":"Credits - Contributing to nuntius","doc":"nuntius has been improved by\n[many contributors](https://github.com/2Latinos/nuntius/graphs/contributors)!","ref":"contributing.html#credits"},{"type":"extras","title":"License","doc":"# License\n\nThe MIT License (MIT)\nCopyright (c) 2022 Fernando Benavides Rodriguez and Paulo Ferraz de Oliveira\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nSee the [Releases](https://github.com/2Latinos/nuntius/releases) page.","ref":"changelog.html"}],"content_type":"text/plain","producer":{"name":"ex_doc","version":[48,46,51,50,46,50]}}